#include "ExpAvr.h"

/// 指数平均を行い最新の値を返す
/// @param double val 入力値
/// @return double 移動平均後の値
double ExpAvr::getOutput(double val)
{
    int a;
    // 入力値で初期化
    if(first){
        first = false;
        for(a = 0; a < order; a++){
            acc[a] = val;
        }
        return val;
    }
    // 各段の値を計算
    for(a = 0; a < order; a++){
        acc[a] = tc * acc[a] + (1.0 - tc) * val;
        val = acc[a];
    }
    return val;
}
